#!/bin/sh
exec scsh -lel install-lib/load.scm -dm -o install-orion -e install-program-main -s "$0" "$@"
!#

(define-structure install-orion (export install-program-main)
  (open scheme-with-scsh
        install-lib)
  (begin
    (define orion-template #<<END
#!/bin/sh
exec scsh -lel module-system-1.0/load.scm -lel interaction-0.2/load.scm -lel cml-1.0/load.scm -lel heap-images-1.0/load.scm -lel scx-0.2/load.scm -lm ~a/packages.scm -m main -s "$0"
!#
(start)

END
)

    (define-program "orion" (0 2) ((install-lib-version (1 1)))
      ;; Install documentation
      (install-file "doc/user.html" 'doc "html")

      ;; Install Scheme code
      (install-directory-contents "src" 'scheme)

      ;; Install script
      (install-string (format #f orion-template (get-directory 'scheme #f))
       "orion"
        'bin 
        "."
         #o555))))
